#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_everyday_task.h"
#include "FileEncrypt.h"
std::auto_ptr<M_everyday_task> M_everyday_task::msSingleton(nullptr);

int M_everyday_task::GetCount()
{
	return (int)mMapData.size();
}

const M_everyday_taskData* M_everyday_task::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int, M_everyday_taskData>& M_everyday_task::GetMapData()
{
	return mMapData;
}

void M_everyday_task::Reload()
{
	mMapData.clear();
	Load();
}

void M_everyday_task::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_everyday_taskData data;
		data.mID = element->IntAttribute("ID");
		data.mtaskType = element->IntAttribute("taskType");
		data.mdes = element->Attribute("des");
		{
			int64_t temp = 0;
			const char* str = element->Attribute("parameter");
			tinyxml2::XMLUtil::ToInt64(str, &temp);
			data.mparameter = temp;
		}
		{
			const char* reward = element->Attribute("reward");
			std::vector<std::string> vecreward;
			boost::split(vecreward, reward, boost::is_any_of(","));
			int temp;
			for (unsigned int i = 0; i < vecreward.size(); i++)
			{
				if (tinyxml2::XMLUtil::ToInt(vecreward[i].c_str(), &temp))
				{
					data.mreward.push_back(temp);
				}
			}
		}
		data.munlock = element->IntAttribute("unlock");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_everyday_task::Load()
{
	Load("../Config/M_everyday_task.xml");
}

M_everyday_task* M_everyday_task::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_everyday_task());
	}
	return msSingleton.get();
}
